using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ADX_Custom_SaveAs_CS
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("3E828843-6913-40DD-B142-BFE94437B458"), ProgId("ADX_Custom_SaveAs_CS.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.MSO.ADXRibbonTab adxRibbonTab1;
        private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton2;
        private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton3;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton4;
        private AddinExpress.MSO.ADXBuiltInControl adxBuiltInControl1;
        private AddinExpress.MSO.ADXRibbonCommand adxRibbonCommand1;
        private AddinExpress.MSO.ADXRibbonButton adxRibbonButton3;
        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
        private AddinExpress.MSO.ADXRibbonGroup adxRibbonGroup1;
        private AddinExpress.MSO.ADXRibbonButton adxRibbonButton1;
        private AddinExpress.MSO.ADXRibbonButton adxRibbonButton2;
        private AddinExpress.MSO.ADXWordAppEvents adxWordEvents;
        private AddinExpress.MSO.ADXExcelAppEvents adxExcelEvents;
        private AddinExpress.MSO.ADXPowerPointAppEvents adxPowerPointEvents;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonCommand1 = new AddinExpress.MSO.ADXRibbonCommand(this.components);
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton1 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonButton2 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
            this.adxCommandBarButton3 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxCommandBarButton4 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxBuiltInControl1 = new AddinExpress.MSO.ADXBuiltInControl(this.components);
            this.adxRibbonButton3 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxWordEvents = new AddinExpress.MSO.ADXWordAppEvents(this.components);
            this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
            this.adxPowerPointEvents = new AddinExpress.MSO.ADXPowerPointAppEvents(this.components);
            // 
            // adxRibbonCommand1
            // 
            this.adxRibbonCommand1.Id = "adxRibbonCommand_7d735e81c34d40939d8f2c9571862fa9";
            this.adxRibbonCommand1.IdMso = "FileSave";
            this.adxRibbonCommand1.Ribbons = ((AddinExpress.MSO.ADXRibbons)(((AddinExpress.MSO.ADXRibbons.msrExcelWorkbook | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            this.adxRibbonCommand1.OnAction += new AddinExpress.MSO.ADXRibbonCommand_EventHandler(this.adxRibbonCommand1_OnAction);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Add-in Express";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_01d065df75194375a79a3902e11a80bf";
            this.adxRibbonTab1.Ribbons = ((AddinExpress.MSO.ADXRibbons)((((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead | AddinExpress.MSO.ADXRibbons.msrExcelWorkbook)
                        | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Add-in Express Group";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton1);
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton2);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_02b0ff543b6b445b9e5d29f5a79f743b";
            this.adxRibbonGroup1.Ribbons = ((AddinExpress.MSO.ADXRibbons)((((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead | AddinExpress.MSO.ADXRibbons.msrExcelWorkbook)
                        | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            // 
            // adxRibbonButton1
            // 
            this.adxRibbonButton1.Caption = "Custom Save As...";
            this.adxRibbonButton1.Id = "adxRibbonButton_b2d6ee527ff04e5da62e82d4f9be06ec";
            this.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton1.Ribbons = ((AddinExpress.MSO.ADXRibbons)((((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead | AddinExpress.MSO.ADXRibbons.msrExcelWorkbook)
                        | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            this.adxRibbonButton1.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton1_OnClick);
            // 
            // adxRibbonButton2
            // 
            this.adxRibbonButton2.Caption = "Custom Open";
            this.adxRibbonButton2.Id = "adxRibbonButton_f5a3414524fb4e74b2389424b3fcf0ab";
            this.adxRibbonButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton2.Ribbons = ((AddinExpress.MSO.ADXRibbons)((((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead | AddinExpress.MSO.ADXRibbons.msrExcelWorkbook)
                        | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            this.adxRibbonButton2.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton2_OnClick);
            // 
            // adxCommandBar1
            // 
            this.adxCommandBar1.CommandBarName = "Add-in Express";
            this.adxCommandBar1.CommandBarTag = "809d616b-659f-4fc8-b98c-f77505c01539";
            this.adxCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxCommandBar1.Controls.Add(this.adxCommandBarButton2);
            this.adxCommandBar1.SupportedApps = ((AddinExpress.MSO.ADXOfficeHostApp)(((AddinExpress.MSO.ADXOfficeHostApp.ohaExcel | AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
                        | AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint)));
            this.adxCommandBar1.UpdateCounter = 31;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "Custom Save As...";
            this.adxCommandBarButton1.ControlTag = "03e88bf6-8dc8-497c-bba4-9965966d4031";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.UpdateCounter = 4;
            this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
            // 
            // adxCommandBarButton2
            // 
            this.adxCommandBarButton2.Caption = "Custom Open";
            this.adxCommandBarButton2.ControlTag = "edbfd29a-f5e4-4b6f-be2b-a82fb2b3c417";
            this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton2.UpdateCounter = 4;
            this.adxCommandBarButton2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton2_Click);
            // 
            // adxOlInspectorCommandBar1
            // 
            this.adxOlInspectorCommandBar1.CommandBarName = "Add-in Express";
            this.adxOlInspectorCommandBar1.CommandBarTag = "51689d9f-cf94-4ce9-affa-091bb7d59e19";
            this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton3);
            this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton4);
            this.adxOlInspectorCommandBar1.Temporary = true;
            this.adxOlInspectorCommandBar1.UpdateCounter = 30;
            // 
            // adxCommandBarButton3
            // 
            this.adxCommandBarButton3.Caption = "Custom Save As...";
            this.adxCommandBarButton3.ControlTag = "cb98d3bd-5a8a-406c-a307-0d73a1ebdd6d";
            this.adxCommandBarButton3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton3.Temporary = true;
            this.adxCommandBarButton3.UpdateCounter = 8;
            this.adxCommandBarButton3.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton3_Click);
            // 
            // adxCommandBarButton4
            // 
            this.adxCommandBarButton4.Caption = "Custom Open";
            this.adxCommandBarButton4.ControlTag = "566675be-0766-4ef2-aa9a-804e78d37000";
            this.adxCommandBarButton4.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton4.Temporary = true;
            this.adxCommandBarButton4.UpdateCounter = 8;
            this.adxCommandBarButton4.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton4_Click);
            // 
            // adxBuiltInControl1
            // 
            this.adxBuiltInControl1.CommandBar = null;
            this.adxBuiltInControl1.ControlTag = "146c04b7-440c-49e2-9e39-3d9d3b34227d";
            this.adxBuiltInControl1.Id = 3;
            this.adxBuiltInControl1.ActionEx += new AddinExpress.MSO.ADXActionEx_EventHandler(this.adxBuiltInControl1_ActionEx);
            // 
            // adxRibbonButton3
            // 
            this.adxRibbonButton3.Caption = "adxRibbonButton3";
            this.adxRibbonButton3.Id = "adxRibbonButton_e892086bb8bd4a20b836ccd22f7a3edd";
            this.adxRibbonButton3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton3.Ribbons = ((AddinExpress.MSO.ADXRibbons)(((AddinExpress.MSO.ADXRibbons.msrExcelWorkbook | AddinExpress.MSO.ADXRibbons.msrWordDocument)
                        | AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation)));
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
            // 
            // adxWordEvents
            // 
            this.adxWordEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxWordEvents_WindowActivate);
            // 
            // adxExcelEvents
            // 
            this.adxExcelEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxExcelEvents_WindowActivate);
            // 
            // adxPowerPointEvents
            // 
            this.adxPowerPointEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxPowerPointEvents_WindowActivate);
            // 
            // AddinModule
            // 
            this.AddinName = "ADX_Custom_SaveAs_CS";
            this.SupportedApps = ((AddinExpress.MSO.ADXOfficeHostApp)((((AddinExpress.MSO.ADXOfficeHostApp.ohaExcel | AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
                        | AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)
                        | AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint)));
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        public PowerPoint._Application PowerPointApp
        {
            get
            {
                return (HostApplication as PowerPoint._Application);
            }
        }

        public Word._Application WordApp
        {
            get
            {
                return (HostApplication as Word._Application);
            }
        }

        private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
        {
            Outlook._MailItem mailItem = (inspector as Outlook.Inspector).CurrentItem as Outlook._MailItem;
            if (mailItem != null)
                try
                {
                    adxOlInspectorCommandBar1.Visible = mailItem.Sent;
                }
                finally
                {
                    Marshal.ReleaseComObject(mailItem);
                }
        }

        private void adxWordEvents_WindowActivate(object sender, object hostObj, object window)
        {
            adxCommandBarButton1.Enabled = true;
            adxRibbonButton1.Enabled = true;
            if (FindUniqueID((window as Word.Window).Document.CustomDocumentProperties))
            {
                adxCommandBarButton1.Enabled = false;
                adxRibbonButton1.Enabled = false;
            }
        }

        private void adxExcelEvents_WindowActivate(object sender, object hostObj, object window)
        {
            adxCommandBarButton1.Enabled = true;
            adxRibbonButton1.Enabled = true;
            Excel._Workbook workbook = (window as Excel.Window).Parent as Excel._Workbook;
            if (workbook != null)
                try
                {
                    if (FindUniqueID(workbook.CustomDocumentProperties))
                    {
                        adxCommandBarButton1.Enabled = false;
                        adxRibbonButton1.Enabled = false;
                    }
                }
                finally
                {
                    Marshal.ReleaseComObject(workbook);
                }
        }

        private void adxPowerPointEvents_WindowActivate(object sender, object hostObj, object window)
        {
            adxCommandBarButton1.Enabled = true;
            adxRibbonButton1.Enabled = true;
            if (FindUniqueID((window as PowerPoint.DocumentWindow).Presentation.CustomDocumentProperties))
            {
                adxCommandBarButton1.Enabled = false;
                adxRibbonButton1.Enabled = false;
            }
        }

        private void adxRibbonButton1_OnClick(object sender, AddinExpress.MSO.IRibbonControl control, bool pressed)
        {
            adxCommandBarButton1_Click(sender);
        }

        private void adxRibbonButton2_OnClick(object sender, AddinExpress.MSO.IRibbonControl control, bool pressed)
        {
            adxCommandBarButton2_Click(sender);
        }

        private void adxCommandBarButton3_Click(object sender)
        {
            adxCommandBarButton1_Click(sender);
        }

        private void adxCommandBarButton4_Click(object sender)
        {
            adxCommandBarButton2_Click(sender);
        }

        public void adxCommandBarButton1_Click(object sender)
        {
            Form1 form1 = new Form1();
            if (form1 != null)
                try
                {
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
                    {
                        Word._Document document = WordApp.ActiveDocument;
                        if (document != null)
                            try
                            {
                                string pathFileDocument = document.FullName;
                                if ((File.Exists(pathFileDocument)) && (document.Saved))
                                {
                                    form1.textBox1.Text = document.Name;
                                    if (form1.ShowDialog() != DialogResult.OK)
                                        return;
                                    string pathFileSaveDocument = Path.GetTempPath() + form1.textBox1.Text;
                                    object FileName = pathFileSaveDocument;
                                    object FileFormat = Type.Missing;
                                    object LockComments = Type.Missing;
                                    object Password = Type.Missing;
                                    object AddToRecentFiles = Type.Missing;
                                    object WritePassword = Type.Missing;
                                    object ReadOnlyRecommended = Type.Missing;
                                    object EmbedTrueTypeFonts = Type.Missing;
                                    object SaveNativePictureFormat = Type.Missing;
                                    object SaveFormsData = Type.Missing;
                                    object SaveAsAOCELetter = Type.Missing;

                                    AddUniqueID(document.CustomDocumentProperties);

                                    document.SaveAs(ref FileName, ref FileFormat, ref LockComments,
                                        ref Password, ref AddToRecentFiles, ref WritePassword,
                                        ref ReadOnlyRecommended, ref EmbedTrueTypeFonts,
                                        ref SaveNativePictureFormat, ref SaveFormsData, ref SaveAsAOCELetter);

                                    FileName = pathFileDocument;
                                    object ConfirmConversions = Type.Missing;
                                    object ReadOnly = Type.Missing;
                                    AddToRecentFiles = Type.Missing;
                                    object PasswordDocument = Type.Missing;
                                    object PasswordTemplate = Type.Missing;
                                    object Revert = Type.Missing;
                                    object WritePasswordDocument = Type.Missing;
                                    object WritePasswordTemplate = Type.Missing;
                                    object Format = Type.Missing;
                                    object Encoding = Type.Missing;
                                    object Visible = true;

                                    WordApp.Documents.Open(ref FileName, ref ConfirmConversions,
                                        ref ReadOnly, ref AddToRecentFiles, ref PasswordDocument,
                                        ref PasswordTemplate, ref Revert, ref WritePasswordDocument,
                                        ref WritePasswordTemplate, ref Format, ref Encoding, ref Visible);

                                    object SaveChanges = Type.Missing;
                                    object OriginalFormat = Type.Missing;
                                    object RouteDocument = Type.Missing;
                                    document.Close(ref SaveChanges, ref OriginalFormat, ref RouteDocument);

                                    SaveToDataBase(0, pathFileSaveDocument);
                                }
                                else
                                {
                                    MessageBox.Show("Please save the document!");
                                }
                            }
                            finally
                            {
                                Marshal.ReleaseComObject(document);
                            }
                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaExcel)
                    {
                        Excel._Workbook excelWorkbook = ExcelApp.ActiveWorkbook;
                        if (excelWorkbook != null)
                            try
                            {
                                try
                                {
                                    ExcelApp.Interactive = false;
                                    ExcelApp.Interactive = true;
                                    if (excelWorkbook.Saved != true)
                                    {
                                        MessageBox.Show("Please save the workbook!");
                                        return;
                                    }
                                    try
                                    {
                                        form1.textBox1.Text = excelWorkbook.Name;
                                        if (form1.ShowDialog() != DialogResult.OK)
                                            return;
                                        string pathFileSaveDocument = Path.GetTempPath() + form1.textBox1.Text;
                                        AddUniqueID(excelWorkbook.CustomDocumentProperties);
                                        excelWorkbook.SaveCopyAs(pathFileSaveDocument);
                                        RemoveUniqueID(excelWorkbook.CustomDocumentProperties);
                                        excelWorkbook.Save();

                                        SaveToDataBase(1, pathFileSaveDocument);
                                    }
                                    catch (Exception e)
                                    {
                                        MessageBox.Show(e.Message);
                                    }
                                }
                                catch
                                {
                                    MessageBox.Show("Please exit the input or editing mode.");
                                }
                            }
                            finally
                            {
                                Marshal.ReleaseComObject(excelWorkbook);
                            }
                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint)
                    {
                        PowerPoint._Presentation presentation = PowerPointApp.ActivePresentation;
                        if (presentation != null)
                            try
                            {
                                if (presentation.Saved != Office.MsoTriState.msoTrue)
                                {
                                    MessageBox.Show("Please save the presentation!");
                                    return;
                                }
                                form1.textBox1.Text = presentation.Name;
                                if (form1.ShowDialog() != DialogResult.OK)
                                    return;
                                string pathFileSaveDocument = Path.GetTempPath() + form1.textBox1.Text;
                                AddUniqueID(presentation.CustomDocumentProperties);
                                presentation.SaveCopyAs(pathFileSaveDocument, PowerPoint.PpSaveAsFileType.ppSaveAsDefault,
                                    Office.MsoTriState.msoTriStateMixed);
                                RemoveUniqueID(presentation.CustomDocumentProperties);
                                presentation.Save();

                                SaveToDataBase(2, pathFileSaveDocument);
                            }
                            finally
                            {
                                Marshal.ReleaseComObject(presentation);
                            }
                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)
                    {
                        Outlook._Inspector inspector = OutlookApp.ActiveInspector();
                        if (inspector != null)
                            try
                            {
                                Outlook._MailItem mailItem = inspector.CurrentItem as Outlook._MailItem;
                                if (mailItem != null)
                                    try
                                    {
                                        form1.textBox1.Text = mailItem.Subject;
                                        if (form1.textBox1.Text == string.Empty)
                                            form1.textBox1.Text = "Subject";
                                        if (form1.ShowDialog() != DialogResult.OK)
                                            return;
                                        string pathFileSaveDocument = Path.GetTempPath() + form1.textBox1.Text + ".msg";
                                        mailItem.SaveAs(pathFileSaveDocument, Outlook.OlSaveAsType.olMSG);

                                        SaveToDataBase(3, pathFileSaveDocument);
                                    }
                                    finally
                                    {
                                        Marshal.ReleaseComObject(mailItem);
                                    }
                            }
                            finally
                            {
                                Marshal.ReleaseComObject(inspector);
                            }
                    }
                }
                finally
                {
                    form1.Dispose();
                }
        }

        private void adxCommandBarButton2_Click(object sender)
        {
            Form2 form2 = new Form2();
            if (form2 != null)
                try
                {
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
                    {
                        form2.listBox1.Items.Clear();

                        localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
                        foreach (string i in service.GetListOfData(0))
                        {
                            form2.listBox1.Items.Add(i);
                        }
                        if (form2.ShowDialog() != DialogResult.OK)
                            return;
                        string loadFile = Path.GetTempPath() + form2.listBox1.Text;
                        File.WriteAllBytes(loadFile, service.LoadData(0, form2.listBox1.Text));
                        service.Dispose();

                        if (File.Exists(loadFile))
                        {
                            fileNamesForDeleting.Add(loadFile);

                            object FileName = loadFile;
                            object ConfirmConversions = Type.Missing;
                            object ReadOnly = Type.Missing;
                            object AddToRecentFiles = Type.Missing;
                            object PasswordDocument = Type.Missing;
                            object PasswordTemplate = Type.Missing;
                            object Revert = Type.Missing;
                            object WritePasswordDocument = Type.Missing;
                            object WritePasswordTemplate = Type.Missing;
                            object Format = Type.Missing;
                            object Encoding = Type.Missing;
                            object Visible = true;
                            WordApp.Documents.Open(ref FileName, ref ConfirmConversions, ref ReadOnly, ref AddToRecentFiles,
                                     ref PasswordDocument, ref PasswordTemplate, ref Revert, ref WritePasswordDocument,
                                     ref WritePasswordTemplate, ref Format, ref Encoding, ref Visible);
                        }
                        else
                        {
                            MessageBox.Show("File does not exist!");
                        }
                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaExcel)
                    {
                        try
                        {
                            ExcelApp.Interactive = false;
                            ExcelApp.Interactive = true;
                            try
                            {
                                form2.listBox1.Items.Clear();

                                localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
                                foreach (string i in service.GetListOfData(1))
                                {
                                    form2.listBox1.Items.Add(i);
                                }
                                if (form2.ShowDialog() != DialogResult.OK)
                                    return;
                                string loadFile = Path.GetTempPath() + form2.listBox1.Text;
                                File.WriteAllBytes(loadFile, service.LoadData(1, form2.listBox1.Text));
                                service.Dispose();

                                if (File.Exists(loadFile))
                                {
                                    fileNamesForDeleting.Add(loadFile);

                                    ExcelApp.Workbooks.Open(loadFile, Type.Missing, Type.Missing, Type.Missing,
                                        Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                                        Type.Missing, Type.Missing, Type.Missing, Type.Missing);
                                }
                                else
                                {
                                    MessageBox.Show("File does not exist!");
                                }
                            }
                            catch (Exception e)
                            {
                                MessageBox.Show(e.Message);
                            }
                        }
                        catch
                        {
                            MessageBox.Show("Please exit the input or editing mode.");
                        }

                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint)
                    {
                        form2.listBox1.Items.Clear();

                        localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
                        foreach (string i in service.GetListOfData(2))
                        {
                            form2.listBox1.Items.Add(i);
                        }
                        if (form2.ShowDialog() != DialogResult.OK)
                            return;
                        string loadFile = Path.GetTempPath() + form2.listBox1.Text;
                        File.WriteAllBytes(loadFile, service.LoadData(2, form2.listBox1.Text));
                        service.Dispose();
                        if (File.Exists(loadFile))
                        {
                            fileNamesForDeleting.Add(loadFile);

                            PowerPointApp.Presentations.Open(loadFile, Office.MsoTriState.msoFalse,
                                Office.MsoTriState.msoFalse, Office.MsoTriState.msoTrue);
                        }
                        else
                        {
                            MessageBox.Show("File does not exist!");
                        }
                    }
                    if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)
                    {
                        form2.listBox1.Items.Clear();

                        localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
                        foreach (string i in service.GetListOfData(3))
                        {
                            form2.listBox1.Items.Add(i);
                        }
                        if (form2.ShowDialog() != DialogResult.OK)
                            return;
                        string loadFile = Path.GetTempPath() + form2.listBox1.Text;
                        File.WriteAllBytes(loadFile, service.LoadData(3, form2.listBox1.Text));
                        service.Dispose();

                        if (File.Exists(loadFile))
                        {
                            fileNamesForDeleting.Add(loadFile);

                            System.Diagnostics.Process.Start(loadFile);
                        }
                        else
                        {
                            MessageBox.Show("File does not exist!");
                        }
                    }
                }
                finally
                {
                    form2.Dispose();
                }
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            foreach (string pathArray in fileNamesForDeleting)
            {
                if (File.Exists(pathArray))
                    try
                    {
                        File.Delete(pathArray);
                    }
                    catch {}
            }
        }

        private void adxBuiltInControl1_ActionEx(object sender, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            ControlAction(e);
        }

        private void adxRibbonCommand1_OnAction(object sender, AddinExpress.MSO.IRibbonControl control, bool pressed, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            ControlAction(e);
        }

        private void ControlAction(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            e.Cancel = false;
            if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaWord)
            {
                Word._Document document = WordApp.ActiveDocument;
                if (document != null)
                    try
                    {
                        if (FindUniqueID(document.CustomDocumentProperties))
                        {
                            e.Cancel = true;
                            string pathFileSave = document.FullName;
                            document.Save();
                            string fileTemp = Path.GetTempPath() + Guid.NewGuid().ToString();
                            File.Copy(pathFileSave, fileTemp, true);

                            SaveToDataBase(0, fileTemp, Path.GetFileName(pathFileSave));
                        }
                    }
                    finally
                    {
                        Marshal.ReleaseComObject(document);
                    }
            }
            if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaExcel)
            {
                Excel._Workbook excelWorkbook = ExcelApp.ActiveWorkbook;
                if (excelWorkbook != null)
                    try
                    {
                        try
                        {
                            ExcelApp.Interactive = false;
                            ExcelApp.Interactive = true;
                            try
                            {
                                if (FindUniqueID(excelWorkbook.CustomDocumentProperties))
                                {
                                    e.Cancel = true;
                                    string pathFileSave = excelWorkbook.FullName;
                                    excelWorkbook.Save();
                                    string fileTemp = Path.GetTempPath() + Guid.NewGuid().ToString();
                                    File.Copy(pathFileSave, fileTemp, true);

                                    SaveToDataBase(1, fileTemp, Path.GetFileName(pathFileSave));
                                }
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Show(ex.Message);
                            }
                        }
                        catch
                        {
                            MessageBox.Show("Please exit the input or editing mode.");
                        }
                    }
                    finally
                    {
                        Marshal.ReleaseComObject(excelWorkbook);
                    }
            }
            if (HostType == AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint)
            {
                PowerPoint._Presentation presentation = PowerPointApp.ActivePresentation;
                if (presentation != null)
                    try
                    {
                        if (FindUniqueID(presentation.CustomDocumentProperties))
                        {
                            e.Cancel = true;
                            string pathFileSave = presentation.FullName;
                            presentation.Save();
                            string fileTemp = Path.GetTempPath() + Guid.NewGuid().ToString();
                            File.Copy(pathFileSave, fileTemp, true);

                            SaveToDataBase(2, fileTemp, Path.GetFileName(pathFileSave));
                        }
                    }
                    finally
                    {
                        Marshal.ReleaseComObject(presentation);
                    }
            }
        }

        private void SaveToDataBase(int type, string pathFileSaveDocument)
        {
            localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
            try
            {
                service.SaveData(type, Path.GetFileName(pathFileSaveDocument), File.ReadAllBytes(pathFileSaveDocument));
            }
            finally
            {
                service.Dispose();
                File.Delete(pathFileSaveDocument);
            }
        }

        private void SaveToDataBase(int type, string pathFileSaveDocument, string fileName)
        {
            localhost.Service1 service = new ADX_Custom_SaveAs_CS.localhost.Service1();
            try
            {
                service.SaveData(type, fileName, File.ReadAllBytes(pathFileSaveDocument));
            }
            finally
            {
                service.Dispose();
                File.Delete(pathFileSaveDocument);
            }
        }

        private void AddUniqueID(object props)
        {
            Office.DocumentProperties properties = (Office.DocumentProperties)props;
            if (properties != null)
                try
                {
                    bool nameExists = false;
                    foreach (Office.DocumentProperty prop in properties)
                    {
                        if (prop.Name == "MyUniqueID")
                        {
                            nameExists = true;
                            break;
                        }
                    }
                    if (!nameExists)
                        properties.Add("MyUniqueID", false, Office.MsoDocProperties.msoPropertyTypeString, "MyUniqueID", Type.Missing);
                }
                finally
                {
                    Marshal.ReleaseComObject(properties);
                }
        }

        private void RemoveUniqueID(object props)
        {
            Office.DocumentProperties properties = (Office.DocumentProperties)props;
            if (properties != null)
                try
                {
                    foreach (Office.DocumentProperty prop in properties)
                    {
                        if (prop.Name == "MyUniqueID")
                        {
                            prop.Delete();
                            break;
                        }
                    }
                }
                finally
                {
                    Marshal.ReleaseComObject(properties);
                }
        }

        private bool FindUniqueID(object props)
        {
            Office.DocumentProperties properties = (Office.DocumentProperties)props;
            if (properties != null)
                try
                {
                    foreach (Office.DocumentProperty prop in properties)
                    {
                        if (prop.Name == "MyUniqueID")
                            return true;
                    }
                }
                finally
                {
                    Marshal.ReleaseComObject(properties);
                }
            return false;
        }

        private List<string> fileNamesForDeleting = new List<string>();
    }
}

